﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.78
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private xui As XUI 'ignore
	'
	Private m_gainP As Double
	Private m_gainI As Double
	Private m_gainD As Double
	'
	Private m_currentError As Double
	Private m_previousError As Double
	Private m_integral As Double
	Private m_output As Double
	'
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	'
	m_currentError = 0
	m_previousError = 0
	m_integral = 0
	m_output = 0
	'
	m_gainP = 1
	m_gainP = 1
	m_gainP = 1
	'
End Sub

Public Sub setGains(p As Double, i As Double, d As Double)
	'
	m_gainP = p
	m_gainI = i
	m_gainD = d
	'
End Sub

Public Sub setError(e As Double)
	'
	m_currentError = e
	'
End Sub

public Sub getError As Double
	'
	Return m_currentError
	'
End Sub

'differential equation of a PID controller
' dt = TimeStep
Public Sub Tick(dt As Double)
	'
	' Integral
	m_integral = dt * (m_integral + m_currentError) ' Sum of all errors + currrent
	' Differential
	Dim derivative As Double = (1/dt) * (m_currentError - m_previousError)
	' PID equation
	m_output = m_gainP * m_currentError + m_gainI * m_integral + m_gainD * derivative
	' memorizing of the current error for the next loop
	m_previousError = m_currentError
	'
End Sub


Public Sub getOutput() As Double
	'
	Return m_output
	'
End Sub